/* Facilidades para depuracao.
O handler de teclado jah deve estah instalado.
CUIDADO COM OS PONTOS-E-VIRGULA NO FINAL DAS MACROS! CONFUSAO NAS CHAMADAS */



// verifica se jah foi incluido o header para comandos de saida: printf
#ifndef __dj_include_stdio_h_
	#include <stdio.h>
#endif



// verifica se jah foi incluido o header para comando exit
#ifndef __dj_include_stdlib_h_
	#include <stdlib.h>
#endif



// verifica se jah foi incluido o header para comandos de teclado
#ifndef TECLADO
	#include "teclado.h"
#endif



// verifica se jah foi incluido o header para comandos do cursor de tela
#ifndef __dj_include_conio_h_
	#include "conio.h"
#endif



// espera tecla ser pressionada para continuar
#define DEP_PAUSA \
{ \
	CTeclado \
		oT; \
	oT.mRetTeclas (); \
}



// avalia condicao, se nao for satisfeita emite mensagem de aviso e faz pausa
#define DEP_TESTA(C) \
{ \
	if ( ! ( C ) ) { \
   	printf ( "FALHA CONDICAO: %s, arquivo: %s, linha: %d.\n", #C, __FILE__, __LINE__ ); \
		CTeclado \
			 oT; \
		oT.mRetTeclas (); \
   } \
}



// avalia condicao, se nao for satisfeita solicita alguma acao, util em loops
#define DEP_TESTA_OP(C) \
{ \
	if ( ! ( C ) ) { \
   	printf ( "FALHA CONDICAO: %s, arquivo: %s, linha: %d.\n", #C, __FILE__, __LINE__ ); \
   	printf ( "[i]gnorar; '[b]reak'; '[e]xit'; '[c]ontinue'\n" ); \
      char \
      	chTecla = 0; \
      while ( chTecla != T_I && chTecla != T_B && \
		        chTecla != T_E && chTecla != T_C ) { \
   		CTeclado \
				oT; \
      	chTecla = oT.mRetTeclas (); \
      } \
      if ( chTecla == T_I ) \
      	;                   \
      if ( chTecla == T_B )   \
			break;                \
      if ( chTecla == T_E )     \
			exit ( 1 );             \
      if ( chTecla == T_C )       \
			continue;                 \
   } \
}



// declara e inicia variavel de contagem de passagem (ver DEP_TESTA_PASS)
#define DEP_DECLARA_PASS(V) INT (V) = 0;



// atribui valor a variavel de contagem de passagem (ver DEP_TESTA_PASS)
#define DEP_INICIA_PASS(V,X) (V) = X;



// se execucao passou pela macro mais de L vezes executa comandos
#define DEP_TESTA_PASS(V,L) \
{ \
	if ( V > L ) { \
   	printf ( "LIMITE: %s > %s, arquivo: %s, linha: %d.\n", #V, #L, __FILE__, __LINE__ ); \
   	printf ( "[i]gnorar; [r]econtar; '[b]reak'; '[e]xit'; '[c]ontinue'\n" ); \
      char \
      	chTecla = 0; \
      while ( chTecla != T_I && chTecla != T_B && \
		        chTecla != T_E && chTecla != T_C && chTecla != T_R ) { \
   		CTeclado \
				oT; \
      	chTecla = oT.mRetTeclas (); \
      } \
      if ( chTecla == T_I ) \
      	;                   \
      if ( chTecla == T_R ) \
      	V = 0;              \
      if ( chTecla == T_B )   \
			break;                \
      if ( chTecla == T_E )     \
			exit ( 1 );             \
      if ( chTecla == T_C )       \
			continue;                 \
   } \
   else    \
   	V ++; \
}



// posiciona cursor de texto no inicio da tela
#define DEP_INICIO_TELA \
{ \
	gotoxy ( 1, 1 ); \
}



// posiciona cursor de texto numa certa linha da tela
#define DEP_LINHA_TELA(L) \
{ \
	gotoxy ( 1, L ); \
}



// mostra mensagem na tela
#define DEP_MOSTRA(M) \
{ \
	printf ( M ); \
}



// mostra mensagem e o valor de uma variavel int, nao quebra linha
#define DEP_MOSTRA_INT_NQ(M,V) \
{ \
	printf ( M ); \
	printf (" ( %d )", ( V ) ); \
}



// mostra mensagem e o valor de uma variavel int, quebra linha
#define DEP_MOSTRA_INT(M,V) \
{ \
	printf ( M ); \
	printf (" ( %d )\n", ( V ) ); \
}



// mostra o valor de uma variavel int e quebra linha se condicao satisfeita
#define DEP_MOSTRA_INT_SE(V,C) \
{ \
	if ( C ) \
		printf (" %s: %d \n", ( #C ), ( V ) ); \
}



// mostra o valor de uma variavel string, quebra linha
#define DEP_MOSTRA_STR(V) \
{ \
	printf (" ( %s )\n", ( V ) ); \
}



// mostra o valor de uma variavel int e faz pausa, quebra linha
#define DEP_MOSTRA_INT_PAUSA(V) \
{ \
	printf (" ( %d )\n", ( V ) ); \
	CTeclado \
		oT; \
	oT.mRetTeclas (); \
}



// mostra o valor de uma variavel string e faz pausa, quebra linha
#define DEP_MOSTRA_STR_PAUSA(V) \
{ \
	printf (" ( %s )\n", ( V ) ); \
	CTeclado \
		oT; \
	oT.mRetTeclas (); \
}



// testa teclado, se tecla definida for pressionada executa return
#define DEP_RETURN(T,R) \
{                        \
	CTeclado               \
		oT;                  \
	if ( oT.mRetPress ( T ) )\
		return R;              \
}



// exibe numero da linha onde a macro estah, bom para ver se executou IF,...
#define DEP_PASSOU printf ( " EXECUTOU LINHA %d\n", __LINE__ )
